#include "J2sae.h"

/************************************** Fonctiuons de Chargement ********************************************/
/****************************************** Et de sauvegarde*************************************************/
/************************************************************************************************************/

Candidat ** chargementCandidats(int *tMax)
{
    FILE *flot;
    Candidat **tCand, *c;
    int i;
    flot = fopen("Candidats.don", "r");
    if(flot == NULL)
    {
        printf("Erreur lors de l'ouverture du fichier candidat\n");
        fclose(flot);
        exit(1);
    }
    fscanf(flot, "%d", tMax);
    printf("tMax : %d\n", *tMax);
    tCand = (Candidat **)malloc(sizeof(Candidat *) * (*tMax));
    printf("Allocation du tableau\n");
    if(tCand == NULL)
    {
        printf("Erreur d'allocation mémoire tableau candidat\n");
        fclose(flot);
        exit(1);
    }
    for(i = 0; i < *tMax; i++)
    {
        c = lireCandidat(flot);
        tCand[i] = c;
    }
    fclose(flot);
    return tCand;
}

Candidat * lireCandidat(FILE *flot)
{
    Candidat *c;
    Choix choix;
    int i = 0;
    c = (Candidat *)malloc(sizeof(Candidat));
    if(c == NULL)
    {
        printf("Erreur d'allocation mémoire candidat\n");
        exit(1);
    }
    fscanf(flot, "%d%*c", &c->numeroC);
    fgets(c->nom, 31, flot);
    c->nom[strlen(c->nom) - 1] = '\0';
    fgets(c->prenom, 31, flot);
    c->prenom[strlen(c->prenom) - 1] = '\0';
    fscanf(flot, "%f%f%f%f%*c", &c->notes[0], &c->notes[1], &c->notes[2], &c->notes[3]);
    fscanf(flot, "%d%*c", &c->nombreChoix);
    c->tChoix = (Choix **)malloc(sizeof(Choix *) * c->nombreChoix);
    while(i < c->nombreChoix)
    {
        c->tChoix[i] = lireChoix(flot);
        i = i + 1;
    }
    return c;
}

Choix * lireChoix(FILE *flot)
{
    Choix *c;
    c = (Choix *)malloc(sizeof(Choix));
    if(c == NULL)
    {
        printf("Erreur d'allocation mémoire choix\n");
        exit(1);
    }
    fgets(c->ville, 31, flot);
    c->ville[strlen(c->ville) - 1] = '\0';
    fgets(c->dep, 31, flot);
    c->dep[strlen(c->dep) - 1] = '\0';
    fscanf(flot, "%d%d%*c", &c->decisionResp, &c->decisionCand);
    return c;
}

void sauvegarder(Candidat *tCand[], int tMax)
{
    FILE *flot;
    int i, j;
    flot = fopen("CandidatsSauv.don", "w");
    if(flot == NULL)
    {
        printf("Erreur de l'ouverture du fichier lors de l'enregistrement\n");
        fclose(flot);
        exit(1);
    }
    fprintf(flot, "%d\n", tMax);
    for(i = 0; i < tMax; i++)
    {
        fprintf(flot, "%d\n%s\n%s\n%d\n", tCand[i]->numeroC, tCand[i]->nom, tCand[i]->prenom, tCand[i]->nombreChoix);
        for(j = 0; j < tCand[i]->nombreChoix; j++)
        {
            fprintf(flot, "%s\n%s\n%d\n%d\n", tCand[i]->tChoix[j]->ville, tCand[i]->tChoix[j]->dep, tCand[i]->tChoix[j]->decisionResp, tCand[i]->tChoix[j]->decisionCand);
        }
    }
    fclose(flot);
    return;
}


/***************************************** Fonctions d'affichage ********************************************/
/************************************************************************************************************/
/************************************************************************************************************/

void afficherChoix(Choix *c)
{
    printf("|_____________________________________________________________________________|\n");
    printf("| %-32s | %-32s | %1d | %1d |\n", c->ville, c->dep, c->decisionResp, c->decisionCand);
    printf("|-----------------------------------------------------------------------------|\n");
}

void afficherCandidat(Candidat *c)
{
    printf("|------------------------------------------------------------------------------------------------------------|\n");
    printf("| %-4d | %-32s | %-32s | %2.2f | %2.2f | %2.2f | %2.2f |\n", c->numeroC, c->nom, c->prenom, c->notes[0], c->notes[1], c->notes[2], c->notes[3]);
    printf("|------------------------------------------------------------------------------------------------------------|\n");
}

void afficherCandChoix(Candidat *tCand[],int tMax)
{
    int i, j;
    for(i = 0; i < tMax; i++)
    {
        printf("______________________________________________________________________________________________________________\n");
        printf("|                                                    Candidat                                                |\n");
        afficherCandidat(tCand[i]);
        printf("\n");
        printf("_______________________________________________________________________________\n");
        printf("|                                  Choix                                      |\n");
        for(j = 0; j < tCand[i]->nombreChoix; j++)
        {
            afficherChoix(tCand[i]->tChoix[j]);
        }
    }
}


/************************************ Fonctions de réallocation *********************************************/
/************************************************************************************************************/
/************************************************************************************************************/

Candidat ** reallocationCand(Candidat *tCand[], int tMax)
{
    Candidat **aux;
    aux = (Candidat **)realloc(tCand, sizeof(Candidat *) * tMax + 1);
    if(aux == NULL)
    {
        printf("Erreur lors de la réallocation du tableau\n");
    }
    return aux;
}

Choix ** reallocationChoix(Choix *tChoix[], int nbChoix)
{
    Choix **aux;
    aux = (Choix **)realloc(tChoix, sizeof(Choix *) * nbChoix + 1);
    if(aux == NULL)
    {
        printf("Erreur lors de la réallocation du tableau\n");
    }
    printf("Réallocation réussie :\n");
    return aux;
}


/************************************* Fonctions de tri *****************************************************/
/************************************************************************************************************/
/************************************************************************************************************/

void triCandidats(Candidat *tCand[], int tMax)
{
    int maxi;
    while(tMax > 1)
    {
        maxi = plusGrandCand(tCand, tMax);
        echangerCand(tCand, maxi, tMax - 1);
        tMax = tMax - 1;
    }
}

int plusGrandCand(Candidat *tCand[], int tMax)
{
    int maxi = 0, i;
    for(i = 1; i < tMax; i++)
    {
        if(strcmp(tCand[i]->nom, tCand[maxi]->nom) > 0)
        {
            maxi = i;
        }
    }
    return maxi;
}

void echangerCand(Candidat *tCand[], int i, int j)
{
    printf("Echange\n");
    Candidat *aux;
    aux = tCand[i];
    tCand[i] = tCand[j];
    tCand[j] = aux;
}

void triChoix(Choix *tChoix[], int nombreChoix)
{
    int maxi;
    while(nombreChoix > 1)
    {
        maxi = plusGrandChoix(tChoix, nombreChoix);
        echangerChoix(tChoix, maxi, nombreChoix - 1);
        nombreChoix = nombreChoix - 1;
    }
}

int plusGrandChoix(Choix *tChoix[], int nombreChoix)
{
    int maxi = 0, i;
    for(i = 1; i < nombreChoix; i++)
    {
        if(strcmp(tChoix[i]->ville, tChoix[maxi]->ville) == 0)
        {
            if(strcmp(tChoix[i]->dep, tChoix[maxi]->dep) > 0)
            {
                maxi = i;
            }
        }
        if(strcmp(tChoix[i]->ville, tChoix[maxi]->ville) > 0)
        {
            maxi = i;
        }
    }
    return maxi;
}

void echangerChoix(Choix *tChoix[], int i, int j)
{
    printf("Echange Choix\n");
    Choix *aux;
    aux = tChoix[i];
    tChoix[i] = tChoix[j];
    tChoix[j] = aux;
}


/******************************* Fonctions d'insertion/suppresion/maj ***************************************/
/************************************************************************************************************/
/************************************************************************************************************/

int insererChoix(Choix *tChoix[], int nombreChoix)
{
    int pos, trouve, i;
    char ville[31], dep[31];
    Choix *c;
    printf("Dans quelle ville se trouve la formation que vous souhaitez ajouter à vos choix ?\nSaisie : ");
    scanf("%s%*c", ville);
    printf("\n");
    printf("Quelle est le nom de la formation que vous souhaitez ajouter à vos choix ?\nSaisie : ");
    scanf("%s%*c", dep);
    printf("\n");
    pos = rechercherChoix(tChoix, nombreChoix, ville, dep, &trouve);
    if(trouve == 1)
    {
        printf("Erreur, ce choix figure déjà dans votre liste\n");
        return -1;
    }
    c = (Choix *)malloc(sizeof(Choix));
    if(c == NULL)
    {
        printf("Erreur d'allocation mémoire lors de l'insertion du choix\n");
        return -1;
    }
    strcpy(c->ville, ville);
    strcpy(c->dep, dep);
    c->decisionResp = 0;
    c->decisionCand = 0;
    tChoix = reallocationChoix(tChoix, nombreChoix);
    for(i = nombreChoix; i > pos; i--)
    {
        tChoix[i] = tChoix[i - 1];
    }
    tChoix[pos] = c;
    afficherChoix(tChoix[pos]);
    return nombreChoix + 1;
}


/*********************************** Fonctions de recherche *************************************************/
/************************************************************************************************************/
/************************************************************************************************************/

int rechercherChoix(Choix *tChoix[], int nombreChoix, char ville[], char dep[], int *trouve)
{
    int inf = 0, sup = nombreChoix - 1, m;
    while(inf <= sup)
    {
        m = (inf + sup) / 2;
        if(strcmp(ville, tChoix[m]->ville) == 0 && strcmp(dep, tChoix[m]->dep) == 0)
        {
            *trouve = 1;
            return m;
        }
        if(strcmp(ville, tChoix[m]->ville) > 0)
        {
            inf = m + 1;
        }
        if(strcmp(ville, tChoix[m]->ville) < 0)
        {
            sup = m - 1;
        }
        if(strcmp(ville, tChoix[m]->ville) == 0 && strcmp(dep, tChoix[m]->dep) > 0)
        {
            inf = m + 1;
        }
        if(strcmp(ville, tChoix[m]->ville) == 0 && strcmp(dep, tChoix[m]->dep) < 0)
        {
            sup = m - 1;
        }
    }
    *trouve = 0;
    return inf;
}


int rechercherCandidat(Candidat *tCand[], int tMax, char nom[], char prenom[], int *trouve)
{
    int inf = 0, sup = tMax - 1, m;
    while(inf <= sup)
    {
        m = (inf + sup) / 2;
        if(strcmp(nom, tCand[m]->nom) == 0 && strcmp(prenom, tCand[m]->prenom) == 0)
        {
            *trouve = 1;
            return m;
        }
        if(strcmp(nom, tCand[m]->nom) > 0)
        {
            inf = m + 1;
        }
        if(strcmp(nom, tCand[m]->nom) < 0)
        {
            sup = m - 1;
        }
        if(strcmp(nom, tCand[m]->nom) == 0 && strcmp(prenom, tCand[m]->prenom) > 0)
        {
            inf = m + 1;
        }
        if(strcmp(nom, tCand[m]->nom) == 0 && strcmp(prenom, tCand[m]->prenom) < 0)
        {
            sup = m - 1;
        }
    }
    *trouve = 0;
    return inf;
}

/********************************** Fonction globale et menus ***********************************************/
/************************************************************************************************************/
/************************************************************************************************************/

void globale(void)
{
    int tMax, pos, trouve, i;
    Candidat **tCand, c;
    tCand = chargementCandidats(&tMax);
    sauvegarder(tCand, tMax);
    triCandidats(tCand, tMax);
    afficherCandChoix(tCand, tMax);
    for(i = 0; i < tMax; i++)
    {
        triChoix(tCand[i]->tChoix, tCand[i]->nombreChoix);
    }
    afficherCandChoix(tCand, tMax);
    pos = rechercherChoix(tCand[0]->tChoix, 4, "Aurillac", "Biologie", &trouve);
    printf("Choix trouve : %d\nSa position : %d\nNom Ville : %s\tNom dep : %s\n", trouve, pos, tCand[0]->tChoix[pos]->ville, tCand[0]->tChoix[pos]->dep);
    menuCandidat(tCand, tMax);
}

void menuCandidat(Candidat *tCand[], int tMax)
{
    int pos,trouve, saisie, i;
    char nom[31], prenom[31];
    system("clear");
    printf("Quel est votre nom ?\nSaisie : ");
    scanf("%s%*c", nom);
    printf("\n");
    printf("Quel est votre prenom ?\nSaisie : ");
    scanf("%s%*c", prenom);
    printf("\n");
    pos = rechercherCandidat(tCand, tMax, nom, prenom, &trouve);
    printf("Candidat trouve : %d\nSa position : %d\nNom : %s\tPrenom : %s\n", trouve, pos, tCand[pos]->nom, tCand[pos]->prenom);
    if(trouve == 0)
    {
        printf("Erreur, vous n'êtes pas inscrit dans la base de données\n");
        return;
    }
    printf("Que souhaitez-vous faire ?\n");
    printf("1 Afficher vos choix\n");
    printf("2 Ajouter un choix\n");
    printf("9 Quitter\nSaisie : ");
    scanf("%d%*c", &saisie);
    printf("\n");
    while(saisie != 9)
    {
        system("clear");
        if(saisie == 1)
        {
            for(i = 0; i < tCand[pos]->nombreChoix; i++)
            {
                printf("Affichage des choix\nNombre de choix : %d\n", tCand[pos]->nombreChoix);
                afficherChoix(tCand[pos]->tChoix[i]);
            }
        }
        if(saisie == 2)
        {
            tCand[pos]->nombreChoix = insererChoix(tCand[pos]->tChoix, tCand[pos]->nombreChoix);
        }
        printf("Que souhaitez-vous faire ?\n");
        printf("1 Afficher vos choix\n");
        printf("2 Ajouter un choix\n");
        printf("9 Quitter\nSaisie : ");
        scanf("%d%*c", &saisie);
        printf("\n");
    }
}